SYSSIZE = 0x7F00
.text
SETUPSECS = 4
BOOTSEG = 0x07C0
INITSEG = 0x9000
SETUPSEG = 0x9020
SYSSEG = 0x1000
ROOT_DEV = 0
SWAP_DEV = 0
.globl _main
_main:
mov ax,#BOOTSEG
mov ds,ax
mov ax,#INITSEG
mov es,ax
mov cx,#256
sub si,si
sub di,di
cld
rep
movsw
jmpi go,INITSEG
go: mov di,#0x4000-12
mov ds,ax
mov ss,ax
mov sp,di
mov fs,cx
mov bx,#0x78
push ds
seg fs
lds si,(bx)
mov cl,#6
cld
push di
rep
movsw
pop di
pop ds
movb 4(di),*36
seg fs
mov (bx),di
seg fs
mov 2(bx),es
load_setup:
XOR ah,ah
XOR dl,dl
int 0x13
XOR dx, dx
mov cl,#0x02
mov bx,#0x0200
mov ah,#0x02
mov al,setup_sects
int 0x13
jnc ok_load_setup
push ax
call print_nl
mov bp, sp
call print_hex
pop ax
jmp load_setup
ok_load_setup:
mov si,#disksizes
probe_loop:
lodsb
cbw
mov sectors, ax
cmp si,#disksizes+4
jae got_sectors
xchg ax, cx
XOR dx, dx
XOR bl, bl
mov bh,setup_sects
inc bh
shl bh,#1
mov ax,#0x0201
int 0x13
jc probe_loop
got_sectors:
mov ax,#INITSEG
mov es,ax
mov ah,#0x03
XOR bh,bh
int 0x10
mov cx,#9
mov bx,#0x0007
mov bp,#msg1
mov ax,#0x1301
int 0x10
mov ax,#SYSSEG
mov es,ax
call read_it
call kill_motor
call print_nl
seg cs
mov ax,root_dev
OR ax,ax
jne root_defined
seg cs
mov bx,sectors
mov ax,#0x0208
cmp bx,#15
je root_defined
mov al,#0x1c
cmp bx,#18
je root_defined
mov al,#0x20
cmp bx,#36
je root_defined
mov al,#0
root_defined:
seg cs
mov root_dev,ax
jmpi 0,SETUPSEG
sread: .word 0
head: .word 0
track: .word 0
read_it:
mov al,setup_sects
inc al
mov sread,al
mov ax,es
test ax,#0x0fff
die:
jne die
XOR bx,bx
rp_read:
mov ax,es
sub ax,#SYSSEG
cmp ax,syssize
jbe ok1_read
ret
ok1_read:
mov ax,sectors
sub ax,sread
mov cx,ax
shl cx,#9
add cx,bx
jnc ok2_read
je ok2_read
XOR ax,ax
sub ax,bx
shr ax,#9
ok2_read:
call read_track
mov cx,ax
add ax,sread
cmp ax,sectors
jne ok3_read
mov ax,#1
sub ax,head
jne ok4_read
inc track
ok4_read:
mov head,ax
XOR ax,ax
ok3_read:
mov sread,ax
shl cx,#9
add bx,cx
jnc rp_read
mov ax,es
add ah,#0x10
mov es,ax
XOR bx,bx
jmp rp_read
read_track:
pusha
pusha
mov ax, #0xe2e
mov bx, #7
int 0x10
popa
mov dx,track
mov cx,sread
inc cx
mov ch,dl
mov dx,head
mov dh,dl
AND dx,#0x0100
mov ah,#2
push dx
push cx
push bx
push ax
int 0x13
jc bad_rt
add sp, #8
popa
ret
bad_rt:
push ax
call print_all
XOR ah,ah
XOR dl,dl
int 0x13
add sp, #10
popa
jmp read_track
print_all:
mov cx, #5
mov bp, sp
print_loop:
push cx
call print_nl
cmp cl, #5
jae no_reg
mov ax, #0xe05 - 1 + 'A!'
sub al, cl
int 0x10
mov al, #'X!'
int 0x10
mov al, #':!'
int 0x10
no_reg:
add bp, #2
call print_hex
pop cx
loop print_loop
ret
print_nl:
mov ax, #0xe0d
int 0x10
mov al, #0xa
int 0x10
ret
print_hex:
mov cx, #4
mov dx, (bp)
print_digit:
rol dx, #4
mov ax, #0xe0f
AND al, dl
add al, #0x90
daa
adc al, #0x40
daa
int 0x10
loop print_digit
ret
kill_motor:
push dx
mov dx,#0x3f2
XOR al, al
outb
pop dx
ret
sectors:
.word 0
disksizes:
.byte 36,18,15,9
msg1:
.byte 13,10
.ascii "Loading"
.org 497
setup_sects:
.byte SETUPSECS
root_flags:
.word 1
syssize:
.word SYSSIZE
swap_dev:
.word SWAP_DEV
ram_size:
.word 0
vid_mode:
.word 0xffff
root_dev:
.word ROOT_DEV
boot_flag:
.word 0xAA55
